function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var fetch = require('node-fetch');

var objectPath = require("object-path");

module.exports = function Hypertopic(services) {
  var _this = this;

  this.getView = function (paths) {
    paths = paths instanceof Array ? paths : [paths];
    var uris = paths.map(function (p) {
      return encodeURI(p);
    }).map(function (p) {
      return services.map(function (s) {
        return s + p;
      });
    });
    uris = [].concat.apply([], uris);
    return Promise.all(uris.map(_get)).then(function (l) {
      return l.reduce(_concat, []);
    }).then(_index);
  };

  var _fetch = function _fetch(id, request, success) {
    return fetch(services[0] + '/' + id, request).then(function (x) {
      if (x.ok) {
        return x.json();
      }

      throw new Error(x.statusText);
    }).then(function (x) {
      return success(x);
    });
  };

  this.get = function (o) {
    return _fetch(o._id, {}, function (x) {
      return x;
    });
  };

  this.post = function (o) {
    return _fetch('', {
      method: 'POST',
      headers: headers({
        'Content-Type': 'application/json'
      }),
      credentials: 'include',
      body: JSON.stringify(o)
    }, function (x) {
      return Object.assign(o, {
        _id: x.id,
        _rev: x.rev
      });
    });
  };

  this["delete"] = function (o) {
    return _fetch(o._id, {
      method: 'DELETE',
      credentials: 'include',
      headers: headers({
        'If-Match': o._rev
      })
    }, function (x) {
      return {
        _id: x.id,
        _rev: x.rev
      };
    });
  };

  this.item = function (o) {
    return new Item(_this, _this.get(o)["catch"](function (x) {
      return {
        _id: o._id,
        item_corpus: o.item_corpus
      };
    }));
  };

  headers = function headers(additional) {
    return !_this.credentials ? additional : Object.assign({}, additional, {
      'Authorization': 'Basic ' + Buffer.from("".concat(_this.credentials.name, ":").concat(_this.credentials.password)).toString('base64')
    });
  };

  this.auth = function (name, password) {
    _this.credentials = {
      name: name,
      password: password
    };
    return _this;
  };

  function Item(db, item) {
    this.setAttributes = function (attributes) {
      return item.then(function (o) {
        return Object.assign(o, attributes);
      }).then(db.post);
    };

    this.unsetAttribute = function (key) {
      return item.then(function (o) {
        delete o[key];
        return o;
      }).then(db.post);
    };

    this.setTopic = function (topic, viewpoint) {
      return item.then(function (o) {
        o.topics = o.topics || {};
        o.topics[topic] = {
          viewpoint: viewpoint
        };
        return o;
      }).then(db.post);
    };

    this.unsetTopic = function (topic_id) {
      return item.then(function (o) {
        if (o.topics) delete o.topics[topic_id];
        return o;
      }).then(db.post);
    };

    this.setResource = function (resource_id, content_type, raw_data) {
      return item.then(function (o) {
        return _objectSpread(_objectSpread({}, o), {}, {
          _attachments: _objectSpread(_objectSpread({}, o._attachments), {}, _defineProperty({}, resource_id, {
            content_type: content_type,
            data: Buffer.from(raw_data).toString('base64')
          }))
        });
      }).then(db.post);
    };

    this.unsetResource = function (resource_id) {
      return item.then(function (o) {
        if (o._attachments) {
          delete o._attachments[resource_id];
        }

        return o;
      }).then(db.post);
    };

    this.setLink = function (relation, corpus, item_id) {
      return item.then(function (o) {
        return _objectSpread(_objectSpread({}, o), {}, {
          items: [].concat(_toConsumableArray(o.items || []), [{
            corpus: corpus,
            id: item_id,
            relation: relation
          }])
        });
      }).then(db.post);
    };

    this.unsetLink = function (relation, corpus, item_id) {
      return item.then(function (o) {
        return _objectSpread(_objectSpread({}, o), {}, {
          items: (o.items || []).filter(function (x) {
            return x.id !== item_id || x.corpus !== corpus || x.relation !== relation;
          })
        });
      }).then(db.post);
    };

    this.then = function (x) {
      return item.then(x);
    };

    return this;
  }

  return this;
};

var _get = function _get(uri) {
  return fetch(uri).then(function (x) {
    return x.json();
  })["catch"](function (_) {
    return {
      rows: []
    };
  });
};

var _concat = function _concat(l, x) {
  return l.concat(x.rows);
};

var _ensureExists = function _ensureExists(data, path, value) {
  return objectPath.ensureExists(data, path, value) || value;
};

var _assign = function _assign(data, row) {
  var source = row.value;

  switch (_typeof(source)) {
    case 'number':
      {
        var target = _ensureExists(data, row.key, []);

        target.push(source);
        break;
      }

    case 'object':
      {
        var _target = _ensureExists(data, row.key, {});

        for (var k in source) {
          if (k[0] !== '_') {
            if (!_target[k]) {
              _target[k] = [];
            }

            var values = source[k];
            values = Array.isArray(values) ? values : [values];

            var _iterator = _createForOfIteratorHelper(values),
                _step;

            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                var v = _step.value;
                if (['Sans nom', '', ' '].includes(v) || _target[k].includes(v)) continue;

                _target[k].push(v);
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }
          }
        }

        break;
      }

    default:
      console.error("Type ".concat(_typeof(source), " not handled!"));
  }
};

var _index = function _index(rows) {
  var data = {};
  rows.forEach(function (r) {
    _assign(data, r);
  });
  return data;
};